#include <stdint.h>
#include <string.h>

#ifndef LIBMMP_AUTHOR
	#include "libmmp.h"
#endif

#ifndef LIBMARTY_AUTHOR
	#include "libmarty.h"
#endif

#ifndef MENDPOINTS_H
	#include "mendpoints.h"
#endif

#include "swiperconf.h"

uint8_t HostPayloads[][23] = {

	{'s','n','o','w','p','o','i','n','t', TERM_PAYLOAD}, // 0
	{'s','l','a','t','e','p','o','r','t', TERM_PAYLOAD}, // 1
};

uint8_t TargetPayloads[][23] = {

	{'a','l','a','r','m', TERM_PAYLOAD}, // 3
	{'m','a','r','q','t','t', TERM_PAYLOAD}, // 6
};

uint8_t EndpointPayloads[][2] = {
	{0x00, TERM_PAYLOAD}, // 0
	{ALARM_EPT_DAC, TERM_PAYLOAD}, // 4
	{MARQTT_EPT_PUBLISH, TERM_PAYLOAD},
};

uint8_t MessagePayloads[][23] = {

	{'0', TERM_PAYLOAD}, // 1
	{'0', TERM_PAYLOAD}, // 1

	{'p','u','b','l','i','s','h', TERM_PAYLOAD}, // 7
	{'m','a','r','t','y','/','l','a','m','p','_','c','o','n','t','r','o','l','/','s','e','t', TERM_PAYLOAD}, // 8
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','0','}', TERM_PAYLOAD}, // 9
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','}', TERM_PAYLOAD}, // 10
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','2','}', TERM_PAYLOAD}, // 11
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','3','}', TERM_PAYLOAD}, // 12
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','4','}', TERM_PAYLOAD}, // 13
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','5','}', TERM_PAYLOAD}, // 14
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','6','}', TERM_PAYLOAD}, // 15
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','7','}', TERM_PAYLOAD}, // 16
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','8','}', TERM_PAYLOAD}, // 17
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','9','}', TERM_PAYLOAD}, // 18

	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','0','}', TERM_PAYLOAD},
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','1','}', TERM_PAYLOAD},
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','2','}', TERM_PAYLOAD},
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','3','}', TERM_PAYLOAD},
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','4','}', TERM_PAYLOAD},
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','5','}', TERM_PAYLOAD},
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','6','}', TERM_PAYLOAD},
	{'{','"','s','c','e','n','e','_','r','e','c','a','l','l','"',':',' ','1','7','}', TERM_PAYLOAD},
};

struct RFIDEvent EventRegister[] = {

	{ // alarm deactivate
		.code = "0007999198",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[0],
					TargetPayloads[0],
					EndpointPayloads[1],
				},
				.payloadLen = 5
			},
			.next = NULL,
		},
		.next = NULL
	},

	{ // lights off
		.code = "0008035601",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[1],
					TargetPayloads[1],
					EndpointPayloads[2],
					MessagePayloads[3],
					MessagePayloads[4]
				},
				.payloadLen = 7
			},
			.next = NULL,
		},
		.next = NULL
	},

	{ // lights warmer
		.code = "0008024313",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[1],
					TargetPayloads[1],
					EndpointPayloads[2],
					MessagePayloads[3],
					MessagePayloads[5]
				},
				.payloadLen = 7
			},
			.next = NULL,
		},
		.next = NULL
	},

	{ // lights standard
		.code = "0008073838",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[1],
					TargetPayloads[1],
					EndpointPayloads[2],
					MessagePayloads[3],
					MessagePayloads[6]
				},
				.payloadLen = 7
			},
			.next = NULL,
		},
		.next = NULL
	},

	{ // lights juice
		.code = "0008042984",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[1],
					TargetPayloads[1],
					EndpointPayloads[2],
					MessagePayloads[3],
					MessagePayloads[8]
				},
				.payloadLen = 7
			},
			.next = NULL,
		},
		.next = NULL
	},

	{ // lights red
		.code = "0007994017",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[1],
					TargetPayloads[1],
					EndpointPayloads[2],
					MessagePayloads[3],
					MessagePayloads[9]
				},
				.payloadLen = 7
			},
			.next = NULL,
		},
		.next = NULL
	},

	{ // lights RGB cycle
		.code = "0008036798",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[1],
					TargetPayloads[1],
					EndpointPayloads[2],
					MessagePayloads[3],
					MessagePayloads[9]
				},
				.payloadLen = 7
			},
			.next = NULL,
		},

		.next = &(struct RFIDEvent){ // lights red
			.code = "0008036798",
			.handle = &(struct MartyMessageHandle) {
				.result = MMP_ARG_UNSET,
				.execute = &(struct MMPacket){

					.type = MMP_TYPE_SEND,
					.argument = MMP_SEND_DIRECT,
					.payloads = (uint8_t **)(uint8_t *[]){
						MessagePayloads[0],
						MessagePayloads[1],
						HostPayloads[1],
						TargetPayloads[1],
						EndpointPayloads[2],
						MessagePayloads[3],
						MessagePayloads[10]
					},
					.payloadLen = 7
				},
				.next = NULL,
			},

			.next = &(struct RFIDEvent){ // lights red
				.code = "0008036798",
				.handle = &(struct MartyMessageHandle) {
					.result = MMP_ARG_UNSET,
					.execute = &(struct MMPacket){

						.type = MMP_TYPE_SEND,
						.argument = MMP_SEND_DIRECT,
						.payloads = (uint8_t **)(uint8_t *[]){
							MessagePayloads[0],
							MessagePayloads[1],
							HostPayloads[1],
							TargetPayloads[1],
							EndpointPayloads[2],
							MessagePayloads[3],
							MessagePayloads[11]
						},
						.payloadLen = 7
					},
					.next = NULL,
				},

				.next = &(struct RFIDEvent){ // lights red
					.code = "0008036798",
					.handle = &(struct MartyMessageHandle) {
						.result = MMP_ARG_UNSET,
						.execute = &(struct MMPacket){

							.type = MMP_TYPE_SEND,
							.argument = MMP_SEND_DIRECT,
							.payloads = (uint8_t **)(uint8_t *[]){
								MessagePayloads[0],
								MessagePayloads[1],
								HostPayloads[1],
								TargetPayloads[1],
								EndpointPayloads[2],
								MessagePayloads[3],
								MessagePayloads[4]
							},
							.payloadLen = 7
						},
						.next = NULL,
					},
					.next = NULL
				},
			},
		},
	},

	{ // lights read
		.code = "0008036186",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[1],
					TargetPayloads[1],
					EndpointPayloads[2],
					MessagePayloads[3],
					MessagePayloads[14]
				},
				.payloadLen = 7
			},
			.next = NULL,
		},
		.next = NULL
	},

	{ // lights comfy
		.code = "0007985613",
		.handle = &(struct MartyMessageHandle) {
			.result = MMP_ARG_UNSET,
			.execute = &(struct MMPacket){

				.type = MMP_TYPE_SEND,
				.argument = MMP_SEND_DIRECT,
				.payloads = (uint8_t **)(uint8_t *[]){
					MessagePayloads[0],
					MessagePayloads[1],
					HostPayloads[1],
					TargetPayloads[1],
					EndpointPayloads[2],
					MessagePayloads[3],
					MessagePayloads[20]
				},
				.payloadLen = 7
			},
			.next = NULL,
		},
		.next = NULL
	},

};

int EventLength = sizeof(EventRegister) / sizeof(EventRegister[0]);

int get_rfid_event(char *code) {

	if (code == NULL) {
		return -1;
	}

	for (int i = 0; i < EventLength; i++) {

		if (EventRegister[i].code == NULL) {
			continue;
		}

		if (!strcmp(EventRegister[i].code, code)) {
			return i;
		}
	}

	return -1;
}
